#include <iostream>
#include "Piece.h"

using namespace std;

Piece::Piece(){
	x = -1;
	y = -1;
	type = '?';
}

Piece::Piece(int r, int c){
	x = r;
	y = c;
	type = '_';
}

Piece::Piece(int r, int c, char t){
	x = r;
	y = c;
	type = t;
}

void Piece::moveFwd(){
	if (type == 'X'){
		x++;
	}
	
	else if (type == 'O'){
		x--;
	}
	
	else 
		cout << "Error: trying to move an empty piece forward.";
}

void Piece::moveLeft(){
	if (type == 'X'){
		x++;
		y--;
	}
	
	else if (type == 'O'){
		x--;
		y++;
	}
	
	else 
		cout << "Error: trying to move an empty piece left.";
}

void Piece::moveRight(){
	if (type == 'X'){
		x++;
		y++;
	}
	
	else if (type == 'O'){
		x--;
		y--;
	}
	
	else 
		cout << "Error: trying to move an empty piece left.";
}

void Piece::isTaken(){
	cout << getX() << " " << getY() << "\n\n";
}